/**
 * @name json-comb-core
 * @fileoverview The inner core of json-comb
 * @version 7.1.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/json-comb-core/}
 */

import{flattenAllArrays as O}from"object-flatten-all-arrays";import{fillMissing as N}from"object-fill-missing-keys";import{setAllValuesTo as K}from"object-set-all-values-to";import{mergeAdvanced as $}from"object-merge-advanced";import R from"semver-compare";import E from"lodash.includes";import{noNewKeys as C}from"object-no-new-keys";import h from"lodash.clonedeep";import H from"sort-keys";import W from"p-reduce";import A from"type-detect";import x from"p-one";var I="7.1.9";var ne=I;function w(e){return e!=null}function i(e){return A(e)==="Object"}function D(e){return typeof e=="string"}function v(e){if(e===null)return"null";if(typeof e=="boolean"||typeof e=="number")return e.toString();if(typeof e=="string")return e;if(typeof e=="symbol")throw new TypeError;return`${e}`}function k(e,t){if(e===void 0&&t===void 0)return 0;if(e===void 0)return 1;if(t===void 0)return-1;let o=v(e),u=v(t);return o<u?-1:o>u?1:0}function F(e,t){let o=/^\d+\.\d+\.\d+$/g;return e.match(o)&&t.match(o)?R(e,t):k(e,t)}function T(e){return i(e)||Array.isArray(e)?H(e,{deep:!0,compare:F}):e}function re(e,t){if(arguments.length===0)throw new Error("json-comb-core/getKeyset(): [THROW_ID_11] Inputs missing!");if(w(t)&&!i(t))throw new TypeError(`json-comb-core/getKeysetSync(): [THROW_ID_12] Options object must be a plain object! Currently it's: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);let u={...{placeholder:!1},...t},s,c;return new Promise((f,r)=>{x(e,(n,l)=>i(n)?!1:(s=l,c=n,!0)).then(n=>{if(n){r(Error(`json-comb-core/getKeyset(): [THROW_ID_13] Oops! ${s}th element resolved not to a plain object but to a ${typeof c}
${JSON.stringify(c,null,4)}`));return}return W(e,(l,g)=>$(O(l,{flattenArraysContainingStringsToBeEmpty:!0}),O(g,{flattenArraysContainingStringsToBeEmpty:!0}),{mergeArraysContainingStringsToBeEmpty:!0}),{}).then(l=>{f(K(l,u.placeholder))})})})}function J(e,t){if(arguments.length===0)throw new Error("json-comb-core/getKeysetSync(): [THROW_ID_21] Inputs missing!");if(!Array.isArray(e))throw new Error(`json-comb-core/getKeysetSync(): [THROW_ID_22] Input must be array! Currently it's: ${typeof e}`);if(e.length===0)throw new Error("json-comb-core/getKeysetSync(): [THROW_ID_23] Input array is empty!");if(w(t)&&!i(t))throw new TypeError(`json-comb-core/getKeysetSync(): [THROW_ID_24] Options object must be a plain object! Currently it's: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);let o={},u=h(e),c={...{placeholder:!1},...t},f={flattenArraysContainingStringsToBeEmpty:!0};return u.forEach((r,n)=>{if(!i(r))throw new TypeError(`json-comb-core/getKeysetSync(): [THROW_ID_25] Non-object (${typeof r}) detected within an array! It's the ${n}th element: ${JSON.stringify(r,null,4)}`);o=$(O(o,f),O(r,f),{mergeArraysContainingStringsToBeEmpty:!0})}),o=T(K(o,c.placeholder)),o}function oe(e,t,o){if(arguments.length===0)throw new Error("json-comb-core/enforceKeyset(): [THROW_ID_31] Inputs missing!");if(arguments.length===1)throw new Error("json-comb-core/enforceKeyset(): [THROW_ID_32] Second arg missing!");let s={...{doNotFillThesePathsIfTheyContainPlaceholders:[],placeholder:!1,useNullAsExplicitFalse:!0},...o};if(s.doNotFillThesePathsIfTheyContainPlaceholders.length&&!s.doNotFillThesePathsIfTheyContainPlaceholders.every(c=>D(c)))throw new Error(`json-comb-core/enforceKeyset(): [THROW_ID_33] Array resolvedOpts.doNotFillThesePathsIfTheyContainPlaceholders contains non-string values:
${JSON.stringify(s.doNotFillThesePathsIfTheyContainPlaceholders,null,4)}`);return new Promise((c,f)=>{Promise.all([e,t]).then(([r,n])=>{if(!i(e)){f(Error(`json-comb-core/enforceKeyset(): [THROW_ID_34] Input must resolve to a plain object! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`));return}if(!i(t)){f(Error(`json-comb-core/enforceKeyset(): [THROW_ID_35] Schema, 2nd arg, must resolve to a plain object! Currently it's resolving to: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`));return}c(T(h(N(h(r),h(n),s))))})})}function se(e,t,o){if(arguments.length===0)throw new Error("json-comb-core/enforceKeysetSync(): [THROW_ID_41] Inputs missing!");if(arguments.length===1)throw new Error("json-comb-core/enforceKeysetSync(): [THROW_ID_42] Second arg missing!");if(!i(e))throw new Error(`json-comb-core/enforceKeysetSync(): [THROW_ID_43] Input must be a plain object! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(!i(t))throw new Error(`json-comb-core/enforceKeysetSync(): [THROW_ID_44] Schema object must be a plain object! Currently it's: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);let s={...{doNotFillThesePathsIfTheyContainPlaceholders:[],placeholder:!1,useNullAsExplicitFalse:!0},...o};if(s.doNotFillThesePathsIfTheyContainPlaceholders.length&&!s.doNotFillThesePathsIfTheyContainPlaceholders.every(c=>D(c)))throw new Error(`json-comb-core/enforceKeyset(): [THROW_ID_45] Array resolvedOpts.doNotFillThesePathsIfTheyContainPlaceholders contains non-string values:
${JSON.stringify(s.doNotFillThesePathsIfTheyContainPlaceholders,null,4)}`);return T(N(h(e),t,s))}function le(e,t){if(arguments.length===0)throw new Error("json-comb-core/noNewKeysSync(): [THROW_ID_51] All inputs missing!");if(arguments.length===1)throw new Error("json-comb-core/noNewKeysSync(): [THROW_ID_52] Schema object is missing!");if(!i(e))throw new Error(`json-comb-core/noNewKeysSync(): [THROW_ID_53] Main input (1st arg.) must be a plain object! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(!i(t))throw new Error(`json-comb-core/noNewKeysSync(): [THROW_ID_54] Schema input (2nd arg.) must be a plain object! Currently it's: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);return C(e,t)}function ie(e,t){if(Array.isArray(e)){if(e.length===0)return[]}else throw new TypeError(`json-comb-core/findUnusedSync(): [THROW_ID_61] The first argument should be an array. Currently it's: ${typeof e}`);if(arguments.length>1&&!i(t))throw new TypeError(`json-comb-core/findUnusedSync(): [THROW_ID_62] The second argument, options object, must be a plain object, not ${typeof t}`);let u={...{placeholder:!1,comments:"__comment__"},...t};u.comments||(u.comments="");let s=h(e);function c(r){return r.map(n=>n.charAt(0)==="."?n.slice(1):n)}function f(r,n,l=[],g=""){if(Array.isArray(r)&&r.length===0)return l;let d;if(r.every(p=>i(p))){if(d=J(r),r.length>1){let a=Object.keys(d).filter(y=>r.every(m=>(n&&m[y]===n.placeholder||m[y]===void 0)&&(!n?.comments||!E(y,n.comments))));l=l.concat(a.map(y=>`${g}.${y}`))}let p=[].concat(...Object.keys(d).filter(a=>i(d[a])||Array.isArray(d[a]))),b=p.map(a=>A(d[a])),j=p.map(a=>[].concat(...r.reduce((y,m)=>(m&&w(m[a])&&(!n||m[a]!==n.placeholder)&&(!n?.comments||!E(m[a],n.comments))&&y.push(m[a]),y),[]))),S="",_="";j.length&&j.forEach((a,y)=>{b[y]==="Array"&&(S=`[${y}]`),_=".",l=f(a,n,l,g+_+p[y]+S)})}else r.every(p=>Array.isArray(p))&&r.forEach((p,b)=>{l=f(p,n,l,`${g}[${b}]`)});return c(l)}return f(s,u)}export{oe as enforceKeyset,se as enforceKeysetSync,ie as findUnusedSync,re as getKeyset,J as getKeysetSync,le as noNewKeysSync,T as sortAllObjectsSync,ne as version};
